"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitUntilGroupInService = exports.waitForGroupInService = void 0;
const util_waiter_1 = require("@smithy/util-waiter");
const DescribeAutoScalingGroupsCommand_1 = require("../commands/DescribeAutoScalingGroupsCommand");
const checkState = async (client, input) => {
    let reason;
    try {
        const result = await client.send(new DescribeAutoScalingGroupsCommand_1.DescribeAutoScalingGroupsCommand(input));
        reason = result;
        try {
            const returnComparator = () => {
                const flat_1 = [].concat(...result.AutoScalingGroups);
                const projection_3 = flat_1.map((element_2) => {
                    const filterRes_5 = element_2.Instances.filter((element_4) => {
                        return element_4.LifecycleState == "InService";
                    });
                    const result_6 = [];
                    result_6.push(filterRes_5.length >= element_2.MinSize);
                    element_2 = result_6;
                    return element_2;
                });
                const flat_7 = [].concat(...projection_3);
                return flat_7.includes(false);
            };
            if (returnComparator() == false) {
                return { state: util_waiter_1.WaiterState.SUCCESS, reason };
            }
        }
        catch (e) { }
        try {
            const returnComparator = () => {
                const flat_1 = [].concat(...result.AutoScalingGroups);
                const projection_3 = flat_1.map((element_2) => {
                    const filterRes_5 = element_2.Instances.filter((element_4) => {
                        return element_4.LifecycleState == "InService";
                    });
                    const result_6 = [];
                    result_6.push(filterRes_5.length >= element_2.MinSize);
                    element_2 = result_6;
                    return element_2;
                });
                const flat_7 = [].concat(...projection_3);
                return flat_7.includes(false);
            };
            if (returnComparator() == true) {
                return { state: util_waiter_1.WaiterState.RETRY, reason };
            }
        }
        catch (e) { }
    }
    catch (exception) {
        reason = exception;
    }
    return { state: util_waiter_1.WaiterState.RETRY, reason };
};
const waitForGroupInService = async (params, input) => {
    const serviceDefaults = { minDelay: 15, maxDelay: 120 };
    return (0, util_waiter_1.createWaiter)({ ...serviceDefaults, ...params }, input, checkState);
};
exports.waitForGroupInService = waitForGroupInService;
const waitUntilGroupInService = async (params, input) => {
    const serviceDefaults = { minDelay: 15, maxDelay: 120 };
    const result = await (0, util_waiter_1.createWaiter)({ ...serviceDefaults, ...params }, input, checkState);
    return (0, util_waiter_1.checkExceptions)(result);
};
exports.waitUntilGroupInService = waitUntilGroupInService;
